"""
    --- AUTO-GENERATED DOCSTRING ---
    This docstring is automatically generated by Agent Docstrings v1.2.0
    Do not modify this block directly.
    
    Classes/Functions:
      - Functions:
        - main() (line 19)
    --- END AUTO-GENERATED DOCSTRING ---
"""
import argparse
import sys
from pathlib import Path

from . import core
from . import __version__


def main():
    """Parse CLI arguments and invoke the core processing routine.

    The function exists mainly to bridge the `console_scripts` entry point
    generated by *setuptools* and the internal API provided by
    :pymod:`agent_docstrings.core`.
    """
    parser = argparse.ArgumentParser(
        description="Generate file-level docstrings summarizing classes and functions.",
        formatter_class=argparse.RawTextHelpFormatter,
        epilog="Example:\n  agent-docstrings ./src ./libs"
    )
    parser.add_argument(
        "directories",
        metavar="DIRECTORY",
        nargs="+",
        help="One or more directories to scan for source files.",
    )
    parser.add_argument(
        "-v",
        "--verbose",
        action="store_true",
        help="Enable verbose output to see which files are being processed.",
    )
    parser.add_argument(
        "--version",
        action="version",
        version=f"%(prog)s {__version__}",
    )

    args = parser.parse_args()

    # Check if directories exist before starting
    for d in args.directories:
        if not Path(d).is_dir():
            print(f"Error: Directory not found at '{d}'", file=sys.stderr)
            sys.exit(1)

    core.discover_and_process_files(args.directories, args.verbose)
    print("Done.")

if __name__ == "__main__":
    main()