"""
    --- AUTO-GENERATED DOCSTRING ---
    This docstring is automatically generated by Agent Docstrings v1.2.0
    Do not modify this block directly.
    
    Classes/Functions:
      - Functions:
        - test_process_file_determinism(sample_files_by_language) (line 16)
    --- END AUTO-GENERATED DOCSTRING ---
"""
import pytest
from agent_docstrings.core import process_file

# determinism test ensures that after inserting header once, subsequent runs do not modify the file

def test_process_file_determinism(sample_files_by_language):
    """
    Processes each sample file three times and asserts that after the first processing,
    subsequent runs do not change the file content.
    """
    for language, file_path in sample_files_by_language.items():
        # Read original content
        original = file_path.read_text(encoding='utf-8')
        # First run: may modify file (insert header)
        process_file(file_path)
        first = file_path.read_text(encoding='utf-8')
        # Second run: should not change content
        process_file(file_path)
        second = file_path.read_text(encoding='utf-8')
        # Third run: also should not change content
        process_file(file_path)
        third = file_path.read_text(encoding='utf-8')

        # After first processing, content should stabilize
        assert first == second == third